<?php
/*	mod_namedposting: Allow users to have an alternate name/signature in some forums.
					  This requires template support.
	author: Chris Eaton (tridus@hiredgoons.ca)
	version: 1.2
	license: You are free to use, modify, or redistribute this code so long as I am given credit for the original development somewhere.
			 This code comes with absolutly no warranty.

			 It would be nice (but not required) of you to email me if you find this module useful. :-)
*/
if(!defined("PHORUM")) return;

// replace the name if it got reset by the phorum
function mod_namedposting ($data)
{
	$PHORUM=$GLOBALS["PHORUM"];
	if($PHORUM["DATA"]["LOGGEDIN"] && !empty($_POST["author"])){
		$data["author"] = $_POST["author"];
	}

    return $data;
}

// use the alternate signature if its set for the user
function mod_namedposting_sig ($data)
{
	$PHORUM=$GLOBALS["PHORUM"];
	// if sig handling is disabled, bail out
	if (!$PHORUM["mod_namedposting"]["enable_alt_sig"])
	{
		return $data;
	}

	// if the user doesn't want a signature appended, bail out
	if ($data['meta']['show_signature']==0)
	{
		return $data;
	}

	// disable phorum's signature display for this post, we don't want it trying to add another signature
	// we also don't want it being added again by an edit. :)
	$data['meta']['show_signature']=0;

	$sig = "\n\n";
	// figure out which signature to use, in this case we're using the alternate configuration
	if (@in_array($PHORUM["forum_id"], $PHORUM["mod_namedposting"]["alternate_forums"]))
	{
		$sig .= $PHORUM["user"][$PHORUM["mod_namedposting"]["alternate_sig_field"]];
	}
	// primary signature
	else
	{
		$sig .= $PHORUM["user"][$PHORUM["mod_namedposting"]["primary_sig_field"]];
	}

	$data["body"] .= $sig;
	return $data;
}

// allow users to edit their usernames
function mod_namedposting_edit($data){
	$PHORUM=$GLOBALS["PHORUM"];
	if($PHORUM["mod_namedposting"]["allow_edit"] && !empty($_POST["author"])){
		$data["author"] = $_POST["author"];
	}

    return $data;
}
// setup the variables so that our custom templates can see them
function mod_namedposting_setup_variables()
{
	GLOBAL $PHORUM;

    // variable set so other code knows we're enabled
    $PHORUM["DATA"]["mod_namedposting"] = array();
    $PHORUM["DATA"]["mod_namedposting"]["enabled"] = true;

	// set the two custom variables, if $_POST[author] is set they are doing a preview and we should set them to that
	// otherwise set them to their defaults from the profile
	if (empty($_POST["author"]) && $PHORUM["DATA"]["LOGGEDIN"])
	{
		if (@in_array($PHORUM["forum_id"], $PHORUM["mod_namedposting"]["alternate_forums"]))
		{
			$PHORUM["DATA"]["POST"]["author"] = $PHORUM["user"][$PHORUM["mod_namedposting"]["alternate_field"]];
		}
		else 
		{
			$PHORUM["DATA"]["POST"]["author"] = $PHORUM["user"][$PHORUM["mod_namedposting"]["primary_field"]];
			//echo $PHORUM["user"][$PHORUM["mod_namedposting"]["primary_field"]];
		}
	}
	else
	{
	    $PHORUM["DATA"]["POST"]["author"] = $_POST["author"];
		$PHORUM["DATA"]["POST"]["author"] = $_POST["author"];
	}
}

// mod_avatar support
// this function is called from mod_avatar if both modules are enabled
// it sets the current avatar to either the normal or alternate default based on the forum
// this does not change the avatar that shows up in a users profile
function mod_namedposting_setup_avatar()
{
    GLOBAL $PHORUM;
    if (@in_array($PHORUM["forum_id"], $PHORUM["mod_namedposting"]["alternate_forums"])) {
        if (isset($PHORUM["user"]["mod_avatar"]["alternate_default_avatar"]) && isset($PHORUM['DATA']['mod_avatar_files'])) {
            foreach ($PHORUM['DATA']['mod_avatar_files'] as $id => $avatar) {
                $PHORUM['DATA']['mod_avatar_files'][$id]["default"] = ($id == $PHORUM["user"]["mod_avatar"]["alternate_default_avatar"]);
            }
        }
    }
}

?>
