<?php
/*	mod_namedposting: Allow users to have an alternate name/signature in some forums.
					  This requires template support.
	author: Chris Eaton (tridus@hiredgoons.ca)
	version: 1.2
	license: You are free to use, modify, or redistribute this code so long as I am given credit for the original development somewhere.
			 This code comes with absolutly no warranty.

			 It would be nice (but not required) of you to email me if you find this module useful. :-)
*/
    if(!defined("PHORUM_ADMIN")) return;

	// save settings
    if(count($_POST)){
        if(!empty($_POST["primary_field"])){
            $PHORUM["mod_namedposting"]["primary_field"]=$_POST["primary_field"];
			$PHORUM["mod_namedposting"]["alternate_field"]=$_POST["alternate_field"];
			$PHORUM["mod_namedposting"]["enable_alt_sig"]= ($_POST["enable_alt_sig"]==1) ? true : false;
			$PHORUM["mod_namedposting"]["allow_edit"]= ($_POST["allow_edit"]==1) ? true : false;
			$PHORUM["mod_namedposting"]["primary_sig_field"]=$_POST["primary_sig_field"];
			$PHORUM["mod_namedposting"]["alternate_sig_field"]=$_POST["alternate_sig_field"];
            $PHORUM["mod_namedposting"]["alternate_forums"]=$_POST["alternate_forums"];
		} else {
			$error = "Primary Field must be defined.";
		}

        if(empty($error)){
            if(!phorum_db_update_settings(array("mod_namedposting"=>$PHORUM["mod_namedposting"]))){
                $error="Database error while updating settings.";
            } else {
                echo "Settings Updated<br />";
            }
        } 
    }

    include_once "./include/admin/PhorumInputForm.php";
    $frm =& new PhorumInputForm ("", "post", "Save");
    $frm->hidden("module", "modsettings");
    $frm->hidden("mod", "namedposting");
    $frm->addbreak("Named Posting module settings (1.2)");

	$frm->addmessage("Enter a field name for the primary and alternate configurations. These should exist either as standard Phorum fields or as custom fields that you have defined. The templates should be edited so the user can input values for any custom fields. Please see doc.txt for more information.");
	$frm->addrow("Field to use as primary name (eg: real_name): ", $frm->text_box("primary_field", $PHORUM["mod_namedposting"]["primary_field"]));
	$frm->addrow("Field to use as alternate name (eg: real_name): ", $frm->text_box("alternate_field", $PHORUM["mod_namedposting"]["alternate_field"]));

	$frm->addbreak();
	$frm->addmessage("Weather or not users should be able to edit the Author of their posts when editing the rest of the post.");
	$checked = ($PHORUM["mod_namedposting"]["allow_edit"]) ? 1 : 0;
	$frm->addrow("Allow username editing: ", $frm->checkbox("allow_edit", "1", "", $checked));

	$frm->addbreak();
	$frm->addmessage("Alternate signatures. If enabled, create two custom fields for the two signatures. If you enable this, the standard Phorum signature system is not used, and the 'edit signature' profile option will have no effect. Please see doc.txt for more information.");
	
	$checked = ($PHORUM["mod_namedposting"]["enable_alt_sig"]) ? 1 : 0;
	$frm->addrow("Enable alternate signature system: ", $frm->checkbox("enable_alt_sig", "1", "", $checked));

	$frm->addrow("Field to use as primary (eg: sig1): ", $frm->text_box("primary_sig_field", $PHORUM["mod_namedposting"]["primary_sig_field"]));
	$frm->addrow("Field to use as alternate signature (eg: sig2): ", $frm->text_box("alternate_sig_field", $PHORUM["mod_namedposting"]["alternate_sig_field"]));

	$frm->addbreak();
	$frm->addmessage("Select which forums should use the ALTERNATE configuration. All forums not selected will use the primary name and signature.");

    $forums=phorum_db_get_forums();
    $list=array();
    foreach($forums as $forum_id=>$forum){
        //$list[$forum_id]=$forum["name"];
        if (!$forum["folder_flag"]){
    		$checked = (@in_array($forum_id, $PHORUM["mod_namedposting"]["alternate_forums"]))? 1 : 0;
	    	$frm->addrow($forum["name"], $frm->checkbox("alternate_forums[]", $forum_id, "", $checked));
        }
    }  
    $frm->show();
?>
